unit pal1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Grids, StrUtils, StdCtrls, Menus;

type
  Tpal = class(TForm)
    Timer: TTimer;
    Grille: TStringGrid;
    LabelScore: TLabel;
    ImageCorps: TImage;
    ImageQueueE: TImage;
    ImageQueueO: TImage;
    ImageQueueS: TImage;
    ImageQueueN: TImage;
    ImageGueuleE: TImage;
    ImageGueuleO: TImage;
    ImageGueuleS: TImage;
    ImageGueuleN: TImage;
    ImageGrenouille: TImage;
    MainMenu: TMainMenu;
    MenuJeu: TMenuItem;
    MenuNiveau: TMenuItem;
    MenuNiveauFacile: TMenuItem;
    MenuNiveauMoyen: TMenuItem;
    MenuNiveauDifficile: TMenuItem;
    MenuQuitter: TMenuItem;
    procedure TimerTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure GrilleKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure GrilleDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure MenuJeuClick(Sender: TObject);
    procedure MenuNiveauFacileClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure MenuQuitterClick(Sender: TObject);
  private
    { Dclarations prives }
    procedure InitPartie;
    procedure PlacerGrenouille;
    procedure FinDePartie;
  public
    { Dclarations publiques }
  end;

var
  pal: Tpal;
  Gueule,Queue:TPoint;
  Azimut:Char;
  AllongerSerpent:byte;

implementation

{$R *.dfm}

procedure Tpal.FormCreate(Sender: TObject);
begin
  Grille.Color:=$B0ECF4;
  InitPartie;
end;

procedure Tpal.InitPartie;
var
  c,l:byte;
begin
  MenuJeu.Caption:='[C]ommencer';
  AllongerSerpent:=0;
  Azimut:='E';
  for c:=0 to 49 do
  begin
    Grille.Cells[c,0]:='B';
    Grille.Cells[c,49]:='B';
    for l:=1 to 48 do
    case c of
    0,49: Grille.Cells[c,l]:='B';
    else  Grille.Cells[c,l]:='';
    end;
  end;
  Gueule.X:=15;
  Gueule.Y:=24;
  Queue.X:=10;
  Queue.Y:=24;
  for c:=Queue.X to Gueule.X do
    Grille.Cells[c,Gueule.Y]:=Azimut;
  PlacerGrenouille;
  LabelScore.Caption:='SCORE  0';
end;

procedure Tpal.FinDePartie;
begin
  Timer.Enabled:=false;
  MenuNiveau.Enabled:=true;
  if messagedlg('PERDU !'+#10+#13+'Rejouer ?',mtConfirmation,[MbYes,MbNo],0)=MrYes
  then InitPartie
  else close;
end;

procedure Tpal.PlacerGrenouille;
var
  Grenouille:TPoint;
begin
  randomize;
  repeat
    Grenouille.X:=trunc(random(50));
    Grenouille.Y:=trunc(random(50));
  until Grille.Cells[grenouille.X,Grenouille.Y]='';
  Grille.Cells[Grenouille.X,Grenouille.Y]:='G';
end;

procedure Tpal.TimerTimer(Sender: TObject);
begin
//la geule avance
  Grille.Cells[Gueule.X,Gueule.Y]:=Azimut;
  case AnsiIndexStr(Azimut,['O','E','S','N']) of
  0: inc(Gueule.X,-1);
  1: inc(Gueule.X);
  2: inc(Gueule.Y);
  3: inc(Gueule.Y,-1);
  end;
  case AnsiIndexStr(Grille.Cells[Gueule.X,Gueule.Y],['G','B','O','E','S','N']) of
  0: begin
       AllongerSerpent:=5;
       LabelScore.Caption:='SCORE  '+inttostr(strtoint(RightStr(LabelScore.Caption,length(LabelScore.Caption)-6))+1);
       PlacerGrenouille;
     end;
  1..5: FinDePartie;
  end;
  Grille.Cells[Gueule.X,Gueule.Y]:=Azimut;
//la queue avance
  if AllongerSerpent>0
  then inc(AllongerSerpent,-1)
  else case AnsiIndexStr(Grille.Cells[Queue.X,Queue.Y],['O','E','S','N']) of
       0: begin
            Grille.Cells[Queue.X,Queue.Y]:='';
            inc(Queue.X,-1);
          end;
       1: begin
            Grille.Cells[Queue.X,Queue.Y]:='';
            inc(Queue.X);
          end;
       2: begin
            Grille.Cells[Queue.X,Queue.Y]:='';
            inc(Queue.Y);
          end;
       3: begin
            Grille.Cells[Queue.X,Queue.Y]:='';
            inc(Queue.Y,-1);
          end;
       end;
  Grille.Refresh;
end;

procedure Tpal.GrilleKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Grille.Cells[Gueule.X,Gueule.Y]=Azimut
  then case key of
       80,67   : MenuJeu.OnClick(MenuJeu);
       VK_LEFT : begin if Azimut<>'E' then Azimut:='O';end;
       VK_RIGHT: begin if Azimut<>'O' then Azimut:='E';end;
       VK_UP   : begin if Azimut<>'S' then Azimut:='N';end;
       VK_DOWN : begin if Azimut<>'N' then Azimut:='S';end;
       end;
end;

procedure Tpal.GrilleDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
  if(Acol=Queue.X)and(Arow=Queue.Y)
  then case AnsiIndexStr(Grille.Cells[ACol,ARow],['O','E','S','N']) of
       0: Grille.Canvas.Brush.Bitmap:=ImageQueueO.Picture.Bitmap;
       1: Grille.Canvas.Brush.Bitmap:=ImageQueueE.Picture.Bitmap;
       2: Grille.Canvas.Brush.Bitmap:=ImageQueueS.Picture.Bitmap;
       3: Grille.Canvas.Brush.Bitmap:=ImageQueueN.Picture.Bitmap;
       end
  else
    if(Acol=Gueule.X)and(Arow=Gueule.Y)
    then case AnsiIndexStr(Grille.Cells[ACol,ARow],['O','E','S','N']) of
         0: Grille.Canvas.Brush.Bitmap:=ImageGueuleO.Picture.Bitmap;
         1: Grille.Canvas.Brush.Bitmap:=ImageGueuleE.Picture.Bitmap;
         2: Grille.Canvas.Brush.Bitmap:=ImageGueuleS.Picture.Bitmap;
         3: Grille.Canvas.Brush.Bitmap:=ImageGueuleN.Picture.Bitmap;
         end
    else case AnsiIndexStr(Grille.Cells[ACol,ARow],['B','G','O','E','S','N']) of
           0: Grille.Canvas.Brush.Color:=$66DAEA;
           1: Grille.Canvas.Brush.Bitmap:=ImageGrenouille.Picture.Bitmap;
           2..5: Grille.Canvas.Brush.Bitmap:=ImageCorps.Picture.Bitmap;
         end;
  Grille.Canvas.FillRect(Rect);
end;

procedure Tpal.MenuJeuClick(Sender: TObject);
begin
  Timer.Enabled:=not Timer.Enabled;
  if MenuJeu.Caption='[&C]ommencer'
  then MenuNiveau.Enabled:=false;
  case Timer.Enabled of
  true:  MenuJeu.Caption:='[P]ause';
  false: MenuJeu.Caption:='[P]oursuivre';
  end;
  SetCursorPos(left,top);
end;

procedure Tpal.MenuNiveauFacileClick(Sender: TObject);
begin
  Timer.Interval:=100-(Sender as TMenuItem).Tag*20;
end;

procedure Tpal.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  Timer.Enabled:=false;
  if MenuJeu.Caption='[&P]ause'
  then MenuJeu.Caption:='[P]oursuivre';
  canclose:=messagedlg('Quitter SNAKE ?',mtConfirmation,[mbyes,mbno],0)=mryes;
end;

procedure Tpal.MenuQuitterClick(Sender: TObject);
begin
  close;
end;

end.
